
<p>Kroz sve tri prethodne stranice razmatrali smo sklop koji ostvaruje logičku funkciju čija je tablica istinitosti prikazana u nastavku.</p>

<table class="mlTableCC mlTableVR2">
<thead>
<tr><th>A</th><th>B</th><th>f</th></tr>
</thead>
<tbody>
<tr><td><code>0</code></td><td><code>0</code></td><td><code>0</code></td></tr>
<tr><td><code>0</code></td><td><code>1</code></td><td><code>1</code></td></tr>
<tr><td><code>1</code></td><td><code>0</code></td><td><code>1</code></td></tr>
<tr><td><code>1</code></td><td><code>1</code></td><td><code>0</code></td></tr>
</tbody>
</table>

<p>Naziv te logičke funkcije je <em>Isključivo-ILI</em> (engl. <i>exclusive-OR</i> ili kraće XOR). Logička funkcija Isključivo-ILI na svojem izlazu daje vrijednost jedan samo kada su joj 
vrijednosti dovedene na njezina dva ulaza međusobno različite. Ako su obje vrijednosti 0 ili ako su obje vrijednosti 1, funkcija Isključivo-ILI daje vrijednost 0.</p>

<p>U tablici u nastavku prikazani su simboli kojima prikazujemo sklopove koji obavljaju funkciju Isključivo-ILI.</p>

<table class="mlTableCC">
<tr><td><img src="@#file#(xor-iec.svg)" alt="IEC XOR simbol"></td><td><img src="@#file#(xor-ansi.svg)" alt="ANSI XOR simbol"></td></tr>
<tr><td>Simbol prema IEC-u</td><td>Simbol prema ANSI-ju</td></tr>
</table>

<p>Primjetite oznaku koja je navedena kod IEC-simbola. Zapamtite je ovako: izlaz je jedan kad je broj ulaza na koje je dovedena vrijednost jedan jednak jedan; "=1" se odnosi na broj ulaza. Dok ANSI-simboli svojim oblikom specificiraju funkciju sklopa, IEC-simboli su svi kvadratičasti; kod njih je funkcija specificirana oznakom tj. tekstom koji piše u simbolu.</p>

<p>Funkcija Isključivo-ILI ima mnoštvo praktičnih primjena; čest je gost u kriptografskom sklopovlju, koristi se kod generiranja različitih slijedova brojeva (primjerice, u generatorima pseudo-slučajnih brojeva)
te u zaštitnom kodiranju. Mi ćemo na ovom mjestu posebno istaknuti mogućnost uporabe ove funkcije za upravljivo komplementiranje. Pretpostavimo da želimo sklop koji se ponaša kako je specificirano na slici u nastavku.</p>

<figure style="text-align: center;">
<img src="@#file#(upravinv-hr.svg)" alt="Sklop Upravljivi invertor." border="0">
<figcaption>Specifikacija upravljivog invertora.</figcaption>
</figure>

<p>Prikazani sklop ima dva ulaza: A i Control te jedan izlaz: Y. Kada je na upravljački ulaz Control dovedena vrijednost 0, sklop na svoj izlaz propušta vrijednost koja je dovedena na ulaz A: ako je A=0 tada će i Y biti 0; ako je A=1 tada će i Y biti 1.
Ako se na upravljački ulaz Control dovede vrijednost 1, tada sklop na izlazu daje komplement od vrijednosti koju smo doveli na ulaz A: ako je A=0 tada će Y biti 1; ako je A=1 tada će Y biti 0. Oznaka \(\bar A\) na slici označava komplementarnu vrijednost.</p>

<p>Korisnik ovog sklopa podešavanjem vrijednosti koja se dovodi na upravljački ulaz Control određuje želi li da sklop na svoj izlaz prenosi vrijednost ulaza A ili da prenosi komplementarnu vrijednost od vrijednosti dovedene na ulaz A. Kako se sklop koji generira komplementarnu vrijednost ulaza naziva <em>invertor</em>, ovaj sklop nazivamo <em>upravljivi invertor</em> (korisnik može preko upravljačkog ulaza odrediti radi li se komplementiranje ili ne).</p>

<p>Ovo je lijepo ilustrirano na interaktivnoj simulaciji u nastavku. Prikazana shema se sastoji od sklopa Isključivo-ILI te generatora impulsa čiji je izlaz doveden na prvi ulaz sklopa Isključivo-ILI. Vrijednost
   koja se dovodi na drugi ulaz sklopa Isključivo-ILI (naš upravljački ulaz) može se mijenjati klikom na zasivljenu pločicu. Početno, na tom je ulazu vrijednost 0 pa očekujemo da signal koji se dovodi na prvi ulaz
   prolazi izravno na izlaz sklopa. Promatrajte jedno vrijeme rad sklopa i uočite da je to slučaj. Potom klikom na zasivljenu pločicu promijenite vrijednost koja se dovodi na drugi ulaz na 1. Gledajte sada kakva
   je veza između vrijednosti koja se dovodi na prvi ulaz i vrijednosti koja se pojavljuje na izlazu: uočite da su one komplementarne.</p>

<div style="text-align: center;">
<canvas id="myCanvas" width="320" height="160" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Leon Luttenberger</span>
</div>
<script>
    @#page-include#(Gate.js)
    @#page-include#(Utility.js)
    
    var canvas = document.getElementById("myCanvas");
    var context = canvas.getContext("2d");

    var xorGate = new Gate(0, 0, function (a, b) {
        return a ^ b;
    }, "=1");

    var gateHeight = 80;
    var gateWidth = 60;

    var inputABoxSize = 50;
    var inputBBoxSize = 30;

    var lineLengthA = 100;
    var lineLengthBX = 50;
    var lineLengthBY = 40;
    var lineLengthOutput = 60;

    var inputA;
    var inputB;

    var fontSize = 16;
    context.font = fontSize + "px Arial";

    var clockTimer = 500; //timer for the clock pulse

    draw();

    function draw() {

        context.lineWidth = 1;
        context.fillStyle = "black";
        context.strokeStyle = "black";

        context.clearRect(0, 0, canvas.width, canvas.height);
        xorGate.draw(context, 160, 20, gateWidth, gateHeight);

        // Draw input A

        context.moveTo(xorGate.inputAConnector.x, xorGate.inputAConnector.y);
        context.lineTo(xorGate.inputAConnector.x - lineLengthA, xorGate.inputAConnector.y);
        context.stroke();

        inputA = new Rectangle(
                xorGate.inputAConnector.x - lineLengthA - inputABoxSize,
                xorGate.inputAConnector.y - inputABoxSize / 2,
                inputABoxSize,
                inputABoxSize
        );
        inputA.draw(context, 3);

        context.fillText(
                xorGate.getInputA(),
                inputA.x + inputA.width + 10,
                xorGate.inputAConnector.y - 10
        );
        context.fillText(
                xorGate.getInputA(),
                xorGate.inputAConnector.x - 20,
                xorGate.inputAConnector.y - 10
        );

        drawImpulseClock(inputA, 10, 15);

        // Draw input B

        var xInputB = xorGate.inputBConnector.x - lineLengthBX;
        var yInputB = xorGate.inputBConnector.y + lineLengthBY;

        context.moveTo(xorGate.inputBConnector.x, xorGate.inputBConnector.y);
        context.lineTo(xInputB, xorGate.inputBConnector.y);
        context.stroke();

        context.moveTo(xInputB, xorGate.inputBConnector.y);
        context.lineTo(xInputB, yInputB);
        context.stroke();

        inputB = new Rectangle(
                xInputB - inputBBoxSize / 2,
                yInputB,
                inputBBoxSize,
                inputBBoxSize
        );
        inputB.draw(context, 3);

        context.fillStyle = "gray";
        context.fillRect(inputB.x, inputB.y, inputB.width, inputB.height);
        context.fillStyle = "black";

        context.fillText(
                xorGate.getInputB(),
                inputB.x + inputB.width / 2 - fontSize / 3,
                inputB.y + inputB.height / 2 + fontSize / 3,
                inputBBoxSize
        );
        context.fillText(
                xorGate.getInputB(),
                xorGate.inputBConnector.x - 20,
                xorGate.inputBConnector.y - 10
        );

        // Draw output

        context.moveTo(xorGate.outputConnector.x, xorGate.outputConnector.y);
        context.lineTo(xorGate.outputConnector.x + lineLengthOutput, xorGate.outputConnector.y);
        context.stroke();

        context.fillText(
                xorGate.getOutput(),
                xorGate.outputConnector.x + lineLengthOutput + 10,
                xorGate.outputConnector.y + fontSize / 3
        );
    }

    function drawImpulseClock(box, horizontalMargin, verticalMargin) {
        var graphWidth = box.width - (2 * horizontalMargin);
        var step = graphWidth / 5;

        var xStart = box.x + horizontalMargin;

        var yBottom = box.y + box.height - verticalMargin;
        var yTop = box.y + verticalMargin;

        for (var i = 0; i < 5; i++) {
            var x = xStart + (i * step);
            var y = i % 2 != 0 ? yTop : yBottom;

            context.moveTo(x, y);
            context.lineTo(x + step, y);
            context.stroke();

            if (i != 0) {
                context.moveTo(x, yBottom);
                context.lineTo(x, yTop);
                context.stroke();
            }
        }
    }

    function animate() {
        xorGate.setInputA(xorGate.getInputA() == 0 ? 1: 0);

        draw();

        window.setTimeout(function () {
            animate();
        }, clockTimer);
    }

    window.setTimeout(function () {
        animate();
    }, clockTimer);

    canvas.addEventListener("mousedown", function (event) {
        var mouse = getMousePos(canvas, event);

        if (inputB.containsPoint(mouse.x, mouse.y)) {
            xorGate.setInputB(xorGate.getInputB() == 0 ? 1: 0);
            draw();
        }
    }, true);

</script>

<p>Sklop Isključivo-ILI može se izravno koristiti kao upravljivi invertor. Zamislite da ulaz B koristimo kao upravljački ulaz, i pogledajte prethodnu tablicu u kojoj je opisana funkcija Isključivo-ILI. Pogledajte najprije prvi i treći redak; u njima je B=0 i izlaz f prati ulaz A. Pogledajte sada drugi i četvrti redak; u njima je B=1 i izlaz f komplementaran je ulazu A.</p>

<p>Zapamtite ovu primjenu sklopa Isključivo-ILI. Na nekoliko mjesta u kolegiju trebat ćemo ovakvu funkcionalnost i za njeno ostvarivanje oslonit ćemo se upravo na Isključivo-ILI.</p>
